############################################################
############################################################
##File to illustrate use of R functions mpiBart and mpiPred.
############################################################
############################################################
#--------------------------------------------------
if(1) {# load mpiBart R interface and set bartmpicstem
source('load-pbart.R')
}
#--------------------------------------------------
if(1) {#simulate data
set.seed(99)
n=10000 #in sample sample size
np=20000 #out of sample sample size
p=10
sigma=1.0

X=matrix(runif(p*n),ncol=p) #in-sample x
Xp=matrix(runif(p*np),ncol=p) #out-sample x

f=10*sin(2*pi*X[,1]*X[,2])+(X[,3]-.5)^2+X[,4]+X[,5]
y=f+rnorm(n,sd=sigma)
fp=10*sin(2*pi*Xp[,1]*Xp[,2])+(Xp[,3]-.5)^2+Xp[,4]+Xp[,5]
}
#--------------------------------------------------
if(1) {# run mpiBart
#try it with type='p' or type='m'
#type='p'
type='m'
numnodes=4 #number of nodes to use in mpi bart
numnodespred=4 #number of nodes to use in prediction calculations
parfit=mpiBart(numnodes,bartmpicstem,X,y,Xp,burn=100,nd=500,thin=1,fname='parjunk',numnodespred=numnodespred,verbose=TRUE,type=type)
}
#--------------------------------------------------
if(1 & type=='p') {#plot
#> names(parfit)
#[1] "yhattrain" "sigma"     "yhattest"  "ysdtest"   "timetorun" "my"       
#> length(parfit$yhattest)
#[1] 20000
par(mfrow=c(1,3))
plot(f,parfit$yhattrain);abline(0,1,col='blue',lwd=2)
plot(fp,parfit$yhattest);abline(0,1,col='blue',lwd=2)
plot(parfit$sigma,col="blue")
abline(h=sigma,col="red",lwd=2)
}
#--------------------------------------------------
if(1 & type=='m') {#plot
#> names(parfit)
#[1] "yhattrain" "sigma"     "yhattest"  "timetorun" "my"       
#> dim(parfit$yhattest)
#[1] 20000   500
qts = apply(parfit$yhattest,1,quantile,probs=c(.1,.5,.9))
par(mfrow=c(2,2))
plot(fp,qts[2,],xlab="true f",ylab="posterior predictive median")
abline(0,1,col="blue",lwd=2)
plot(fp,qts[1,],xlab="true f",ylab="posterior predictive 10%")
abline(0,1,col="blue",lwd=2)
plot(fp,qts[3,],xlab="true f",ylab="posterior predictive 90%")
abline(0,1,col="blue",lwd=2)
plot(parfit$sigma,col="blue")
abline(h=sigma,col="red",lwd=2)
}
#--------------------------------------------------
if(1) {#try mpiPred, get predictions on new xp, using (fname)trees.txt, tree draws
set.seed(14)
np=50000
Xp=matrix(runif(p*np),ncol=p) #out-sample x
fp=10*sin(2*pi*Xp[,1]*Xp[,2])+(Xp[,3]-.5)^2+Xp[,4]+Xp[,5]
predres = mpiPred(parfit,numnodespred,bartmpicstem,Xp,fname="parjunk")
qts=apply(predres$yhat,1,quantile,probs=c(.1,.5,.9))
plot(fp,qts[2,],xlab="true f",ylab="posterior predictive median")
}

