#--------------------------------------------------
if(1) {# pbart.R is R wrap of mpi bart code
  bartmpicstem='./' #this we be used in calls to wrap functions
  source(paste(bartmpicstem,'pbart.R',sep='')) #read in R wrap functions
  #source('load-pbart.R')
  #source('pbart.R')
}
#--------------------------------------------------
if(1) {#simulate data
  set.seed(99)
  n=1000 #in sample sample size
  np=2001 #out of sample sample size
  p=10
  sigma=1.0

  X=matrix(runif(p*n),ncol=p) #in-sample x
  Xp=matrix(runif(p*np),ncol=p) #out-sample x

  f=10*sin(2*pi*X[,1]*X[,2])+(X[,3]-.5)^2+X[,4]+X[,5]
  y=f+rnorm(n,sd=sigma)
  fp=10*sin(2*pi*Xp[,1]*Xp[,2])+(Xp[,3]-.5)^2+Xp[,4]+Xp[,5]
}
#--------------------------------------------------
if(1) {# run mpiBart
  numnodes=4 #number of nodes to use in mpi bart
  numnodespred=4 #number of nodes to use in prediction calculations

  # new functionality is the "fname" argument.  Here I assume a subdir
  # called "testout" has been created.  Temporary files will be written
  # there.
  parfit=mpiBart(numnodes,bartmpicstem,X,y,burn=100,nd=500,thin=10,m=20,
    fname='testout/t1',numnodespred=numnodespred,pause=FALSE,verbose=TRUE)
  parpred=mpiPred(parfit,numnodes,bartmpicstem,fname='testout/t1',xp=Xp,
    type='m',verbose=TRUE)
  # also possible... stores in same directory as mpibart
  #parfit=mpiBart(numnodes,bartmpicstem,X,y,burn=100,nd=500,thin=10,m=20,
  #  fname='t1',numnodespred=numnodespred,pause=FALSE,verbose=TRUE)
}


if (1){
# bigger test set check
  set.seed(99)
  n=1000 #in sample sample size
  np=40001 #out of sample sample size
  p=10
  sigma=1.0

  X=matrix(runif(p*n),ncol=p) #in-sample x
  Xp=matrix(runif(p*np),ncol=p) #out-sample x

  f=10*sin(2*pi*X[,1]*X[,2])+(X[,3]-.5)^2+X[,4]+X[,5]
  y=f+rnorm(n,sd=sigma)
  fp=10*sin(2*pi*Xp[,1]*Xp[,2])+(Xp[,3]-.5)^2+Xp[,4]+Xp[,5]

  parfit=mpiBart(numnodes,bartmpicstem,X,y,xp=NULL,burn=100,nd=500,thin=10,m=20,
    fname='testout/t2',numnodespred=numnodespred,pause=FALSE)
  parpred=mpiPred(parfit,numnodes=4,bartmpicstem,xp=Xp,type='m',
    fname='testout/t2')
}

#--------------------------------------------------
if(0) {#plot
  # names(parfit)
  #[1] "yhattrain" "sigma"     "yhattest"  "ysdtest"   "timetorun"
  par(mfrow=c(1,2))
  plot(f,parfit$yhattrain);abline(0,1,col='blue',lwd=2)
  plot(fp,parfit$yhattest);abline(0,1,col='blue',lwd=2)
}
